#ifndef _INC_SLIB_GRAPHICSAVER
#define _INC_SLIB_GRAPHICSAVER
#ifdef SLIB_USE_GRAPHICSAVER


// sN`^Cv
typedef enum
{
	GSPICTYPE_BMP = 10,
	GSPICTYPE_JPG = 20,
	GSPICTYPE_PNG = 30,
	GSPICTYPE_TGA = 40,

}GSPICTURETYPE;

// rbg[x
typedef enum
{
	GSPICBPP_8	= 10,
	GSPICBPP_24 = 30,
	GSPICBPP_32 = 40,

}GSPICTUREBITSPERPIXEL;

// sNZtH[}bg
typedef enum
{
    GSFMT_R8G8B8	= 20,	// 24 rbg RGB sNZ tH[}bg
    GSFMT_A8R8G8B8	= 21,	// At@t 32 rbg ARGB sNZ tH[}bgB
    GSFMT_X8R8G8B8	= 22,	// 32 rbg RGB sNZ tH[}bgŁÂ 8 rbg͊eF̂߂ɊmۂĂB
    GSFMT_R5G6B5	= 23,	// 16 rbg RGB sNZ tH[}bgB
    GSFMT_X1R5G5B5	= 24,	// 16 rbg̃sNZ tH[}bgŁÂ 5 rbg͊eF̂߂ɊmۂĂB
    GSFMT_A1R5G5B5	= 25,	// 16 rbg̃sNZ tH[}bgŁAeF 5 rbgAAt@ (ߌ^eNZ)  1 rbgAꂼmۂĂB 
    GSFMT_A4R4G4B4	= 26,	// 16 rbg ARGB sNZ tH[}bgB
    GSFMT_R3G3B2	= 27,	// 8 rbg RGB eNX` tH[}bgB
    GSFMT_A8R3G3B2	= 29,	// 16 rbg ARGB eNX` tH[}bgB
    GSFMT_X4R4G4B4	= 30,	// 16 rbg RGB sNZ tH[}bgŁÂ 4 rbg͊eF̂߂ɊmۂĂB
	GSFMT_P8		= 41,	// 8 rbg̃J[ CfbNXtH[}bgB

}GSFORMAT;

// ۑ̃C[W\
typedef struct
{
	LPVOID			lpBits;						// sNZobt@
	DWORD			dwSize;						// sNZobt@̃TCY
	DWORD			dwRowBytes;					// 1C̃oCg
	DWORD			dwWidth;					// C[W̕
	DWORD			dwHeight;					// C[W̍
	GSFORMAT		Format;						// C[W̃tH[}bg
	LPRGBQUAD		lpPalette;					// pbg
	BOOL			bTopDown;					// obt@gbv_E`

}GSIMAGEINFO, FAR* LPGSIMAGEINFO;

// ۑ̃sN`\
typedef struct
{
	GSPICTURETYPE			PicType;			// sN`^Cv
	GSPICTUREBITSPERPIXEL	PicBPP;				// sN`rbg[x
	BOOL					bJPEGProgression;	// JPEGpp[^ - vObVuGR[fBO
	DWORD					dwJPEGQuality;		// JPEGpp[^ - i@1`100

}GSPICTUREINFO, FAR* LPGSPICTUREINFO;


// BITMAP̉̃oCg𓾂(4oCgEɏC)
#define GS_GETBMPROWBYTES( w, b ) ((((w)*(b))+3)&~3)

// etH[}bg24rbgRGBlɕϊ}N
#define GS_R5G6B5ToR8( rgb ) (_5[rgb>>11])
#define GS_R5G6B5ToG8( rgb ) (_6[rgb>>5&0x3F])
#define GS_R5G6B5ToB8( rgb ) (_5[rgb&0x1F])
#define GS_A1R5G5B5ToA8( argb ) ((argb>>15)*255)
#define GS_A1R5G5B5ToR8( argb ) (_5[argb>>10&0x1F])
#define GS_A1R5G5B5ToG8( argb ) (_5[argb>>5&0x1F])
#define GS_A1R5G5B5ToB8( argb ) (_5[argb&0x1F])
#define GS_A4R4G4B4ToA8( argb ) (_4[argb>>12&0xF])
#define GS_A4R4G4B4ToR8( argb ) (_4[argb>>8&0xF])
#define GS_A4R4G4B4ToG8( argb ) (_4[argb>>4&0xF])
#define GS_A4R4G4B4ToB8( argb ) (_4[argb&0xF])
#define GS_R3G3B2ToR8( rgb ) (_3[rgb>>5])
#define GS_R3G3B2ToG8( rgb ) (_3[rgb>>2&0x7])
#define GS_R3G3B2ToB8( rgb ) (_2[rgb&0x3])
#define GS_A8R3G3B2ToA8( argb ) (argb>>8)
#define GS_A8R3G3B2ToR8( argb ) (_3[argb>>5&0x7])
#define GS_A8R3G3B2ToG8( argb ) (_3[argb>>2&0x7])
#define GS_A8R3G3B2ToB8( argb ) (_2[argb&0x3])

// e[u쐬}N
#define GS_INIT_565TABLE()						\
BYTE _5[32];									\
BYTE _6[63];									\
for( int i = 0; i < 32; i++ ) _5[i] = i*255/31;	\
for( int j = 0; j < 64; j++ ) _6[j] = j*255/63;	\

#define GS_INIT_555TABLE()						\
BYTE _5[32];									\
for( int i = 0; i < 32; i++ ) _5[i] = i*255/31;	\

#define GS_INIT_444TABLE()						\
BYTE _4[16];									\
for( int i = 0; i < 16; i++ ) _4[i] = i*255/15;	\

#define GS_INIT_332TABLE()						\
BYTE _3[8];										\
BYTE _2[4];										\
for( int i = 0; i < 8; i++ ) _3[i] = i*255/7;	\
for( int j = 0; j < 4; j++ ) _2[j] = j*255/3;	\


/*----------------------------------------------------------------------------*
|	OtBbNۑNX (sNZC[WOtBbNϊ)
*----------------------------------------------------------------------------*/
typedef class CGraphicSaver
{
protected:

	void SaveBitmap( CFile& fin, const LPGSIMAGEINFO lpImgInfo );
	void SaveTarga( CFile& fin, const LPGSIMAGEINFO lpImgInfo );
	void SaveJpeg( CFile& fin, const LPGSIMAGEINFO lpImgInfo, BOOL bProgression, DWORD dwQuality );
	void SavePng( CFile& fin, const LPGSIMAGEINFO lpImgInfo );
	bool ConvertPixel( const LPGSPICTUREINFO lpPicInfo, const LPGSIMAGEINFO lpImgInfo, const selna::shared_array<LPBYTE> ppScanLine, LPGSIMAGEINFO lpNewImgInfo );

public:

	CGraphicSaver();
	virtual ~CGraphicSaver();

	DWORD SavePicture( CFile& fin, const LPGSPICTUREINFO lpPicInfo, const LPGSIMAGEINFO lpImgInfo );
	DWORD SavePicture( CFile& fin, GSPICTURETYPE PicType, GSPICTUREBITSPERPIXEL	PicBPP, BOOL bJPEGProgression, DWORD dwJPEGQuality, LPVOID lpBits, DWORD dwSize, DWORD dwRowBytes, DWORD dwWidth, DWORD dwHeight, GSFORMAT Format, LPRGBQUAD lpPalette, BOOL bTopDown = TRUE );
	DWORD SavePicture( const char* lpszFileName, const LPGSPICTUREINFO lpPicInfo, const LPGSIMAGEINFO lpImgInfo );
	DWORD SavePicture( const char* lpszFileName, GSPICTURETYPE PicType, GSPICTUREBITSPERPIXEL PicBPP, BOOL bJPEGProgression, DWORD dwJPEGQuality, LPVOID lpBits, DWORD dwSize, DWORD dwRowBytes, DWORD dwWidth, DWORD dwHeight, GSFORMAT Format, LPRGBQUAD lpPalette, BOOL bTopDown = TRUE );

}CGRAPHICSAVER, FAR* LPCGRAPHICSAVER;


#endif /* SLIB_USE_GRAPHICSAVER */
#endif /* _INC_SLIB_GRAPHICSAVER */