#ifndef _INC_SLIB_TARGA
#define _INC_SLIB_TARGA

#pragma pack( push, 1 )	// \̂̃TCY1oCgɐ؂߂

// TARGA Ver2.0 (32bit k `lt) wb_|\
typedef struct
{
	BYTE	No_ID;			// 0=C[Whc
	BYTE	CMap_Type;		// 0=J[}bv 1=J[}bvL
	BYTE	Image_Type;		// 0=C[WȂ 1=J[}bv 2=tJ[ 3= 9=kCfbNXJ[ 10=kRGB^Cv 11=k
	WORD	CMap_Origin;	// J[}bvIW
	WORD	CMap_Length;	// J[}bv̒
	BYTE	CMap_EntrySize;	// J[}bṽGg[TCY
	WORD	Ox;				//   X 0Œ
	WORD	Oy;				//   Y 0Œ
	WORD	Width;			//  (dot)
	WORD	Height;			//  (dot)
	BYTE	Pixel;			// Pixel Size. 32=32bit
	BYTE	IDesc_Type;		// 8=TGA32 Agr[g

}TARGAHEADER;

typedef struct
{
	BYTE    blue; 
    BYTE    green; 
    BYTE    red; 
    BYTE    alpha;

}TARGAARGBQUAD, FAR* LPTARGAARGBQUAD;


// TARGA GNXeVGAŎgpt\
typedef struct
{
	short month;			//  1-12
	short day;				//  1-31
	short year;				// N 1999ƂS
	short hour;				//  0-23
	short minute;			//  0-59
	short second;			// b 0-59

}TARGADATE;

// TARGA GNXeVGAŎgp鎞\
typedef struct
{
	short hours;			//  0-65536
	short minute;			//  0-59
	short second;			// b 0-59

}TARGATIME;


// TARGA GNXeVtb^[GA
typedef struct
{
	WORD len;				// ̃GNXeVGA̒ 495Œ
	char author[41];		// Җ(ASCII NULL STOPK{ gȂȂ0Ŗ߂鎖*/
	char comment[324];		// ҂̃RggȂȂ0Ŗ߂鎖
	TARGADATE date;			// 쐬t gȂȂ0Ŗ߂鎖
	char job[41];			// d (Җɓ)
	TARGATIME time;			// 쐬 gȂȂ0Ŗ߂鎖
	char soft[41];			// \tgEFAID (Җɓ)
	short verNunber;		// o[Wio[ * 100(1.01Ȃ101) gȂȂ0Ŗ߂鎖
	char verLot;			// bg(ASCII) gȂȂXy[XZbg
	BYTE keyA;				// L[J[.摜̃ SOȂ獕g
	BYTE keyR;				// L[J[.摜̐
	BYTE keyG;				// L[J[.摜̐
	BYTE keyB;				// L[J[.摜̗
	WORD aspectX;			// hbg̃AXyNgX 0Ȃ疳
	WORD aspectY;			// hbg̃AXyNgY 0Ȃ疳
	WORD gammaN;			// K}l.0.0-10.0
	WORD gammaD;			// K}l.0ZbgƃK}lwȂƂȂ
	long color_ofs;			// J[RNVe[üʒu.ȗȂ0
	long stamp_ofs;			// ȗȂ0
	long scan_ofs;			// ȗȂ0
	char att_type;			// 0:f[^Ȃ 1,2:f[^ 3:`lL 4:pre-multipliedȃf[^

}TARGAEXTFOOTER;


// TARGA tb^[\
typedef struct
{
	DWORD	Ext_Ofs;		// 0=GNXeVGAȂ ȊO̓t@C擪AGNXeVGA܂ł̃oCg
	DWORD	Dev_Ofs;		// 0=fFbp[GAȂ@͂OŒ
	char	Sign[16];		// "TRUEVISION-XFILE"Œ
	BYTE	RFU1;			// "."Œ
	BYTE	RFU2;			// NULL.0 Œ

}TARGAFOOTER;

#pragma pack( pop )


#endif /* _INC_SLIB_TARGA */