#ifndef _INC_CSDIB32GLX86
#define _INC_CSDIB32GLX86


/*----------------------------------------------------------------------------*
|	SDib32GL X86 Class
*----------------------------------------------------------------------------*/
class CSDib32GLX86 : public CSDib32GLBase
{
public:

	/*** ISDib32GL methods ***/
	STDMETHODIMP AlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha );
	STDMETHODIMP ColorKeyAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha );
	STDMETHODIMP AddBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	STDMETHODIMP AddAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha );
	STDMETHODIMP SubBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	STDMETHODIMP SubAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha );
	STDMETHODIMP AlphaChannelBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	STDMETHODIMP AlphaChannelAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha );
	STDMETHODIMP AlphaChannelMaskBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	STDMETHODIMP AlphaChannelMaskAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha );
	STDMETHODIMP RotateAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, int nAngle, LPPOINT lpCenterPt );
	STDMETHODIMP RotateColorKeyAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, int nAngle, LPPOINT lpCenterPt );
	STDMETHODIMP RotateAddBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, int nAngle, LPPOINT lpCenterPt );
	STDMETHODIMP RotateAddAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, int nAngle, LPPOINT lpCenterPt );
	STDMETHODIMP RotateSubBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, int nAngle, LPPOINT lpCenterPt );
	STDMETHODIMP RotateSubAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, int nAngle, LPPOINT lpCenterPt );
	STDMETHODIMP RotateAlphaChannelBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, int nAngle, LPPOINT lpCenterPt );
	STDMETHODIMP RotateAlphaChannelAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, int nAngle, LPPOINT lpCenterPt );
	STDMETHODIMP RotateAlphaChannelMaskBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, int nAngle, LPPOINT lpCenterPt );
	STDMETHODIMP RotateAlphaChannelMaskAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, int nAngle, LPPOINT lpCenterPt );
	STDMETHODIMP UniversalTransBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, LPSDIB32GL lpRuleSDIB32GL, WORD wPhase, BYTE Vague, DWORD dwRuleFlags );
	STDMETHODIMP UniversalTransColorKeyBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, LPSDIB32GL lpRuleSDIB32GL, WORD wPhase, BYTE Vague, DWORD dwRuleFlags );
	STDMETHODIMP UniversalTransAlphaChannelBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, LPSDIB32GL lpRuleSDIB32GL, WORD wPhase, BYTE Vague, DWORD dwRuleFlags );
	STDMETHODIMP RectangleAlpha( int x, int y, int nWidth, int nHeight, SDIB32GLCOLOR Color );
	STDMETHODIMP RectangleAdd( int x, int y, int nWidth, int nHeight, SDIB32GLCOLOR Color );
	STDMETHODIMP RectangleSub( int x, int y, int nWidth, int nHeight, SDIB32GLCOLOR Color );
	STDMETHODIMP LineAlpha( int x0, int y0, int x1, int y1, SDIB32GLCOLOR Color );
	STDMETHODIMP LineAdd( int x0, int y0, int x1, int y1, SDIB32GLCOLOR Color );
	STDMETHODIMP LineSub( int x0, int y0, int x1, int y1, SDIB32GLCOLOR Color );
	STDMETHODIMP EllipseAlpha( int x0, int y0, int rx, int ry, SDIB32GLCOLOR Color );
	STDMETHODIMP EllipseAdd( int x0, int y0, int rx, int ry, SDIB32GLCOLOR Color );
	STDMETHODIMP EllipseSub( int x0, int y0, int rx, int ry, SDIB32GLCOLOR Color );
	STDMETHODIMP Mono( int x, int y, int nWidth, int nHeight, BYTE Strength );
	STDMETHODIMP Sepia( int x, int y, int nWidth, int nHeight, BYTE Strength, SDIB32GLCOLOR Color  );
	STDMETHODIMP Bright( int x, int y, int nWidth, int nHeight, int nBright );
};


#endif /* _INC_CSDIB32GLX86 */